#include "list.h"

void *
AddListEle( List *lst, char *Ele, int size )
{
	List * new;
	List * next;
	List * prev;
	char * tele;
	if(lst == NULL)
		return NULL;
	if(Ele == NULL)
		return NULL;
	new = (List *)calloc(1, sizeof(List));
	if(new == NULL)
		PrintErr("No Memory");
	tele = (char *)calloc(1, size);
	if(tele == NULL)
		PrintErr("No Memory");
    memcpy( tele, Ele, size );
	next = lst;
	prev = lst;
	while(next)
	{
		prev=next;
		next=next->next;
	}
	prev->next = new;
	new->next = NULL;
	new->ele = tele;
	return new;
}

void
DeleteListEle( List *lst, char *Ele, int size )
{
	List *next;
	List *prev;
	if(lst == NULL)
		return ;
	if(Ele == NULL)
		return ;
	prev = lst;
	next = lst;
	while(next)
	{
		if( next->ele != NULL )
		{
			if( !memcmp( Ele, next->ele, size ) )
			{
				prev->next = next->next;
				free(next->ele);
				free(next);
				return;
			}
		}
		prev=next;
		next=next->next;
	}
}

char *
GetNextListEle( List *lst, int flag )
{
	List * tmp;
	char *ele;
	if(lst == NULL)
		return NULL;
	if( flag )
		lst->curr = lst->next;
	if( lst->curr == NULL )
	{
		ele = NULL;
	}
	else 
	{
		tmp = lst->curr;
		lst->curr = lst->curr->next;
		ele = tmp->ele;
	}
	
	return ele;
}

void
ListInit(List* lst)
{
	lst->next=NULL;
	lst->curr=NULL;
	lst->ele=NULL;
}

typedef struct{
int i;
char ch[10];
} Tstruct;

/******
main()
{
	List mylist;
	Tstruct ts;
	Tstruct tts;
	Tstruct *pts;
	ListInit(&mylist);

	ts.i = 23;
	strcpy(ts.ch, "SATISH");
	AddListEle( &mylist, (char *)&ts, sizeof(Tstruct) );

	ts.i = 25;
	strcpy(ts.ch, "KUMAR");
	AddListEle( &mylist, (char *)&ts, sizeof(Tstruct) );
	tts = ts;

	ts.i = 27;
	strcpy(ts.ch, "NAND");
	AddListEle( &mylist, (char *)&ts, sizeof(Tstruct) );

	DeleteListEle( &mylist, (char *)&tts, sizeof(Tstruct) );

	pts = (Tstruct *)GetNextListEle(&mylist, 1);
	printf("I is %d\n", pts->i);
	printf("Ch is %s\n", pts->ch);
	pts = (Tstruct *)GetNextListEle(&mylist, 0);
	printf("I is %d\n", pts->i);
	printf("Ch is %s\n", pts->ch);
}
******/



